Help Contents

COM Up! Help
2001(c) Bitwheel All Rights Reserved.

Bitwheel COM Up!™ Help Topics

Overview

Why COM Up!?
COM Objects (the first part of the program)

Object Details (the second part of the program)
Glossary
How to register?


Overview

Overview

COM Up!™

is made for programmers, web developers, system administrators and for anyone working with COM based technologies (COM, DCOM, COM+, ActiveX).

main features:

  • overview of all COM objects installed on the local system registry
  • safe registering of DLL/OCX/EXE component with rich error report support in case it fails
  • safe unregistering of DLL/OCX/EXE component or only single COM object
  • complete removing of some component (unregistering and deleting server file)
  • COM objects are separated in four different lists according to their server file type (ActiveX controls, DLLs, EXEs and all types together)
  • easy searching and sorting of COM objects by their ProgID, Description, CLSID or status
  • every COM object has its status - it can be proper or dead(missing its server file)
  • for each selected COM object appears a list of its details and a tree showing all registry entries of the object
  • removing all dead COM object entries from the registry and cleaning the registry that way
  • fast and effective comparing of selected COM object with another one
  • report generation(TXT/HTML) with filtering
  • testing ActiveX control in a web page
  • jumping to File Explorer with focusing selected object's server file
  • complete type library info overview of some COM object (if the object has one)
  • tree of all object's types(interfaces, coclasses, enumerations, etc.)
  • details for selected type
  • all members of some selected type separated in functions, variables, methods, properties and all together
  • details for selected type's member
  • etc.


Why COM Up! ?

Why COM Up!™ ?

Simply because it is the best tool around of this kind. It provides almost everything what somebody working with COM needs. It is very easy to use, has many details showed in a friendly environment and user can find what he or she is looking for very fast.

When looking for some ActiveX control/COM object/component fast sorting by specific criteria is crucial. In the same way you want to know what is the functionality of some control, what can you do with it.

The program shows a list of components which provides fast sorting by ProgID, CLSID, Description and Status. In second part of the program there is detailed type information (interfaces, methods and its parameters, properties, variables, etc.). Detailed type information means that you can find out what methods and properties some component provides and what does some method do, or all constants and their default values defined in component, or how much memory it takes, etc.

There has always been the need for getting information about some components functionality. COM Up! offers the overview of all the interfaces, methods, properties and similar. You can see what the component does in a few seconds and you don't need to search its help file or create test applications to see what the can component do.

Web developers can use, in addition to type information, feature of creating test HTML page which containing some ActiveX control. That way you can view ActiveX control in a web page.
When you select some COM object in the list, details and registry entries for that component are automatically showed. Registry entries are especially useful because you see merely all data some COM object has in the registry.

As a matter of registering components, it provides much better solution than regsvr.exe(regsvr32.exe) because it shows error information in case registration fails. It can happen that file isn't COM component, it has no DllRegister function or this function failed to execute, or there simply isn't enough memory or something else.
Unregistering provides user with rich error information in the same way as registering does. Some COM object's registry entries can be removed without actually unregistering its server file and other registered COM objects of that server file.


'Object Details' - second part of the program

Object Details
[second part of the program]

This part of the program provides complete type information for some COM object if the object has registered type library.

Navigator
is a simple toolbar used to navigate through list of COM objects when you are in the Object Details part of the program. Using this buttons you can move back, ahead or to start or end of the list in the COM Objects part of the program. For example, you can easily sort DLLs by their Description column and then move through objects using this toolbar and view their type information. Near the Navigator is caption with the ProgID of the COM object which type information is displayed.

Types
is a list of all types which selected COM object contain. There are nine kinds of types (interfaces, coclasses, enumerations, dispatch interfaces, modules, unions, etc.). When some type is selected, details about it are displayed in the lower left window and the list of type's members are displayed in the upper right window depending on the kind of the selected type.

Type Members
are listed in the upper right window depending what kind of type is selected. There are five tabs (All, Methods, Properties, Variables, Functions) that separate type members in different categories. If we right click any member there will be a pop-up menu to copy selected text to clipboard. When some type member is selected, its details are shown in lower right window, similarly to type details in the left window.


'COM Objects' - first part of the program

COM Objects
[first part of the program]

In this part of the program there is a list of all the COM objects registered in the local registry and the related information and operations.

List of COM Objects
The list has four columns, ProgID, CLSID, Description and Status. One click to the caption of the column sorts the list according to that column. List can show three types of COM objects or all of them together, depending what tab button is selected. Controls stands for ActiveX controls (server file is of .OCX or .DLL type), DLLs are objects which server file is of .DLL type and EXEs are objects which server file is executable(.EXE). When ALL tab is selected, list is filled with all COM objects no matter in what kind of server file they are contained.
If we want to find all ActiveX controls which are missing their server file, we click the tab with Controls caption what makes the list show only COM objects which server files are .OCX. One click on a Status caption of a column puts all dead objects on the top. This simple sorting applies to any column.

Toolbar
Toolbar provides operations to manipulate COM objects from the active list.

- opens a dialog to register some COM file. It can be any .ocx, .dll or .exe file.

- opens a dialog to choose what kind of unregistration of a selected object do you want to perform.
The default and recommended option unregisters the whole server file of the selected COM object. In this case server file remains undeleted but it removes entries from the registry of all COM objects it registered.
The second option removes only entries of the selected COM object and doesn't unregister other objects that have the same server file.

- unregisters selected COM object's server file and deletes it.

- removes all dead servers in the active list. If the active list shows only ActiveX controls, only ActiveX controls that are registered but have no server file will be removed from the registry.
To remove all dead COM objects, i.e. to clean the registry, simply select ALL tab to make the list show all types of objects and than this button will apply to all objects.

- opens a dialog for report creating. You can choose whether you want the report to be in a HTML file as a web page or ASCII text file. You can also choose what to include in the report and the path of the file.

- opens a dialog for comparing selected object with another one

- creates and opens a test web page that contains selected ActiveX control. This option is not valid for COM objects other than ActiveX controls.

- opens File Explorer and selects server file of the selected object.

- searches the registry for the type of objects from the active list and refreshes the list. It will not refresh all types of objects if this button is not pressed while ALL tab is not selected.

Details

Lower-left window shows details of selected COM object. One left click on some text line in the window opens pop-up menu to copy selected text to clipboard.

Registry Entries

Lower-right window shows tree with registry entries of selected COM object. Almost all entries some object has in registry is displayed in this tree. On the right, there is a window which lists all values and data of selected subkey. One left click opens pop-up menu to jump to regedit.exe


Glossary

Glossary

ActiveX (control/component)
is technology based on COM. It was primarily intended to be used on the Internet.
ActiveX control or component can be used in a web page as well as any Win32 application. This kind of components/controls are almost always In-Process, i.e. loaded in some other process in memory and are contained in OCX files and more rarely in DLLs.

COM
Component Object Model is technology developed by Microsoft© to enable interoperability between software applications, easier reusability of software in a form of components, etc. It was used as a base for many new technologies like DCOM, COM+, ASP, etc.

COM Object
is the basic unit of COM. Sometimes is also called component and vice versa. It has to be registered in system registry to be properly used. Its functionality(code) is contained in binary file(OCX, DLL or EXE). Depending on its file, it can be In-Process or Out-Of-Process. InProcess objects are objects contained in DLLs and OCXs and these kind of objects are loaded in some other(caller's) memory process(Win32 application). Out-Of-Process are objects which exist in their own memory process. COM object's functionality and data is accessed over interfaces.

Component
is pretty overloaded term and sometimes refers to COM object. The usual difference between component and COM object is that component refers to a DLL or OCX file which is used by some other container.

Control
has the same functionality as component. The common difference one might have in its mind is that controls usually have graphical appearance(buttons, grids, graphs, etc.) while components not. Controls are based on ActiveX technology and use IDispatch kind of interfaces to access their data and functionality.

Dead COM Object
is COM object which registry entries exist but its server file doesn't. This unnecessary registry entries makes system slow and in many cases cause malfunction of applications which try to use them.

DLL
is a binary file that has to be loaded in other memory process to be used. In-Process COM Objects can be contained in a DLL.

EXE
is a binary executable file which contain Out-Of-Process COM objects. When objects from this file are to be used, EXE file starts its own memory process.

Function
is a type member accessible over IUnknown kind of interface. The main difference between method and a function is that functions are accessed over virtual-table while methods are accessed over IDispatch kind of interface.

Method
is almost the same as function but accessed in the different way. See Function.

Property
is something similar as variable but it is defined by one or more functions. For example, some property can be read and wrote when it has one function for setting its value and other function of the same for reading its value. Can be thought of as a variable on a more abstract level.

Registering
is a process of adding/setting registry subkeys and subkey values in order to put necessary information about one or more COM objects. The main root key for this is HKEY_CLASSES_ROOT.

Registry (entries)
Registry enables COM to function by providing the place where information about COM object can be stored and accessed by other applications. Every COM object has subkeys in registry providing basic information about them called entries. These subkeys are called entries because they are used as an entry point for using COM object.

OCX
file functions in the same way as DLL. The main difference between DLL and OCX is that OCX file contains ActiveX components/controls while DLL not rarely.

Server (COM Server)
refers to the same term as COM Object. In COM something is called server when it provides it functionality to some client which uses it. COM Object is usually server to some application which behaves as a client.

Server File
is another name for binary file which contains code of some COM Object(COM Server). It can be DLL, OCX or EXE.

Type Information
includes all information about types of some COM object and their members.

Type Library
is a binary data in a .TLB file or included as a resource in a server file(DLL, EXE, OCX) which provides type information. Type library must be registered in the registry along with its COM object entries to be properly used.

Type Members
are all functions, variables, methods and properties of some COM object contained in type library.

Types
are all types of some COM objects contained in its type library. There are nine kinds of types. Type contain members depending on its kind(coclasses have no members).

Unregistering
is a process opposite to registering. When unregistering some component, all COM objects that the component registered are removed from the registry. Unregistering process does not include deleting component file from the disk.


How to Register?

How to Register?

Unregistered version of COM Up!™ is fully operable but it contains nag-screens and is used for evaluation within 21 days. After the registration is done you will have full technical support and help on using the program. Registered version of this program is not limited in time and does not contain nag-screens.
Registration is done completely on-line but not necessarily.

To obtain the latest information and to register go to:
http://www.bitwheel-technologies.com/products/comup/comup_order.htm

After the payment is done, you will become a registered user and receive information needed to download the registered version.